Index: /palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3967)
+++ /palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3968)
@@ -687,13 +363,391 @@
              CALL message( 'chem_emissions_matching', 'CM0444', 0, 2, 0, 6, 0 ) 
  
-          ENDIF             
-
-
-       !
-       !-- If emission module is switched on but mode_emis is not specified or it is given the wrong name
+          ENDIF
+
+!
+!-- LOD 1 (DEFAULT mode)
+
+       CASE (1)
+
+          len_index = 0          ! TOTAL number of species (to be accumulated)  
+          len_index_voc = 0      ! TOTAL number of VOCs (to be accumulated)
+          len_index_pm = 3       ! TOTAL number of PMs: PM1, PM2.5, PM10.
+ 
+          IF  ( nvar > 0 .AND. nspec_emis_inp > 0 )  THEN
+
+!
+!-- Cycle over model species
+             DO ind_mod = 1, nvar
+
+!
+!-- Cycle over input species
+
+                DO ind_inp = 1, nspec_emis_inp
+
+!
+!-- Check for VOC Species
+
+                   IF  ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" )  THEN
+                      DO ind_voc= 1, emt_att%nvoc
+                        
+                         IF  ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                            len_index = len_index + 1
+                            len_index_voc = len_index_voc + 1
+                         ENDIF
+                         
+                      END DO
+                   ENDIF
+
+!
+!-- PMs: There is one input species name for all PM 
+!-- This variable has 3 dimensions, one for PM1, PM2.5 and PM10
+
+                   IF  ( TRIM( emt_att%species_name(ind_inp) ) == "PM" )  THEN
+
+                      IF      ( TRIM( spc_names(ind_mod) ) == "PM1" )   THEN
+                         len_index = len_index + 1
+                      ELSEIF  ( TRIM( spc_names(ind_mod) ) == "PM25" )  THEN
+                         len_index = len_index + 1
+                      ELSEIF  ( TRIM( spc_names(ind_mod) ) == "PM10" )  THEN
+                         len_index = len_index + 1
+                      ENDIF
+
+                   ENDIF
+
+!
+!-- NOX: NO2 and NO
+
+                   IF  ( TRIM( emt_att%species_name(ind_inp) ) == "NOX" )  THEN 
+
+                      IF     ( TRIM( spc_names(ind_mod) ) == "NO"  )  THEN
+                         len_index = len_index + 1
+                      ELSEIF  ( TRIM( spc_names(ind_mod) ) == "NO2" )  THEN
+                         len_index = len_index + 1
+                      ENDIF
+
+                   ENDIF
+
+!
+!-- SOX: SO2 and SO4
+
+                   IF  ( TRIM( emt_att%species_name(ind_inp) ) == "SOX" )  THEN
+
+                      IF      ( TRIM( spc_names(ind_mod) ) == "SO2" )  THEN
+                         len_index = len_index + 1
+                      ELSEIF  ( TRIM( spc_names(ind_mod) ) == "SO4" )  THEN
+                         len_index = len_index + 1
+                      ENDIF
+
+                   ENDIF
+
+!
+!-- Other Species
+
+                   IF  ( TRIM( emt_att%species_name(ind_inp) ) ==             &
+                        TRIM( spc_names(ind_mod) ) )  THEN
+                      len_index = len_index + 1
+                   ENDIF
+
+                END DO  ! ind_inp ...
+
+             END DO  ! ind_mod ...
+
+
+!
+!-- Allocate arrays
+
+             IF  ( len_index > 0 )  THEN
+
+                ALLOCATE ( match_spec_input(len_index) )
+                ALLOCATE ( match_spec_model(len_index) )
+
+                IF  ( len_index_voc > 0 )  THEN
+
+!
+!-- Contains indices of the VOC model species
+
+                   ALLOCATE( match_spec_voc_model(len_index_voc) )
+
+!
+!-- Contains the indices of different values of VOC composition
+!-- of input variable VOC_composition
+
+                   ALLOCATE( match_spec_voc_input(len_index_voc) )
+
+                ENDIF
+
+!
+!-- Pass the species indices to declared arrays
+
+                len_index = 0
+                len_index_voc = 0
+                
+                DO ind_mod = 1, nvar
+                   DO ind_inp = 1, nspec_emis_inp 
+
+!
+!-- VOCs
+
+                      IF  ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" .AND.       &
+                           ALLOCATED (match_spec_voc_input) )  THEN
+
+                         DO ind_voc = 1, emt_att%nvoc
+
+                            IF  ( TRIM( emt_att%voc_name(ind_voc) ) ==                  &
+                                 TRIM( spc_names(ind_mod) ) )  THEN
+
+                               len_index     = len_index + 1
+                               len_index_voc = len_index_voc + 1
+                        
+                               match_spec_input(len_index) = ind_inp
+                               match_spec_model(len_index) = ind_mod
+
+                               match_spec_voc_input(len_index_voc) = ind_voc
+                               match_spec_voc_model(len_index_voc) = ind_mod
+
+                            ENDIF
+
+                         END DO
+
+                      ENDIF
+
+!
+!-- PMs
+
+                      IF  ( TRIM( emt_att%species_name(ind_inp) ) == "PM" )  THEN
+
+                         IF      ( TRIM( spc_names(ind_mod) ) == "PM1"  )  THEN
+                            len_index = len_index + 1
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         ELSEIF  ( TRIM( spc_names(ind_mod) ) == "PM25" )  THEN
+                            len_index = len_index + 1
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         ELSEIF  ( TRIM( spc_names(ind_mod) ) == "PM10" )  THEN
+                            len_index = len_index + 1
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         ENDIF
+
+                      ENDIF
+
+!
+!-- NOX 
+                      IF  ( TRIM( emt_att%species_name(ind_inp) ) == "NOX" )  THEN
+
+                         IF      ( TRIM( spc_names(ind_mod) ) == "NO"  )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+
+                         ELSEIF  ( TRIM( spc_names(ind_mod) ) == "NO2" )  THEN
+                            len_index = len_index + 1
+
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+  
+                         ENDIF
+
+                      ENDIF
+
+
+!
+!-- SOX 
+
+                      IF  ( TRIM( emt_att%species_name(ind_inp) ) == "SOX" ) THEN
+
+                         IF  ( TRIM( spc_names(ind_mod) ) == "SO2" )  THEN
+                            len_index = len_index + 1
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         ELSEIF  ( TRIM( spc_names(ind_mod) ) == "SO4" )  THEN
+                            len_index = len_index + 1
+                            match_spec_input(len_index) = ind_inp
+                            match_spec_model(len_index) = ind_mod
+                         ENDIF
+
+                      ENDIF
+
+!
+!-- Other Species
+
+                      IF  ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                         len_index = len_index + 1
+                         match_spec_input(len_index) = ind_inp
+                         match_spec_model(len_index) = ind_mod
+                      ENDIF
+
+                   END DO  ! inp_ind
+
+                END DO     ! inp_mod
+
+!
+!-- Error reporting (no matching)
+
+             ELSE
+
+                message_string = 'None of given Emission Species matches'           //   &
+                                 ' model chemical species'                          //   &
+                                 ' Emission routine is not called'         
+                CALL message( 'chem_emissions_matching', 'CM0440', 0, 0, 0, 6, 0 ) 
+
+             ENDIF
+
+!
+!-- Error reporting (no species)
+
+          ELSE
+
+             message_string = 'Array of Emission species not allocated: '             // &
+                              ' Either no emission species are provided as input or'  // &
+                              ' no chemical species are used by PALM:'                // &
+                              ' Emission routine is not called'                                   
+             CALL message( 'chem_emissions_matching', 'CM0441', 0, 2, 0, 6, 0 ) 
+ 
+          ENDIF
+
+!
+!-- LOD 2 (PRE-PROCESSED mode)
+
+       CASE (2)
+
+          len_index = 0
+          len_index_voc = 0
+
+          IF  ( nvar > 0 .AND. (nspec_emis_inp > 0) )  THEN
+!
+!-- Cycle over model species
+             DO ind_mod = 1, nvar 
+
+!
+!-- Cycle over input species  
+                DO ind_inp = 1, nspec_emis_inp
+
+!
+!-- Check for VOC Species 
+
+                   IF  ( TRIM( emt_att%species_name(ind_inp) ) == "VOC" )  THEN        
+                      DO ind_voc = 1, emt_att%nvoc
+                         IF  ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                            len_index     = len_index + 1
+                            len_index_voc = len_index_voc + 1
+                         ENDIF
+                      END DO
+                   ENDIF
+
+!
+!-- Other Species
+
+                   IF  ( TRIM(emt_att%species_name(ind_inp)) == TRIM(spc_names(ind_mod)) )  THEN
+                      len_index = len_index + 1
+                   ENDIF
+                ENDDO
+             ENDDO
+
+!
+!-- Allocate array for storing the indices of the matched species
+
+             IF  ( len_index > 0 )  THEN
+ 
+                ALLOCATE ( match_spec_input(len_index) ) 
+ 
+                ALLOCATE ( match_spec_model(len_index) )
+
+                IF  ( len_index_voc > 0 )  THEN
+!
+!-- contains indices of the VOC model species
+                   ALLOCATE( match_spec_voc_model(len_index_voc) )
+!
+!-- contains the indices of different values of VOC composition of input variable VOC_composition
+                   ALLOCATE( match_spec_voc_input(len_index_voc) )
+
+                ENDIF
+
+!
+!-- pass the species indices to declared arrays
+
+                len_index = 0
+
+!
+!-- Cycle over model species
+
+                DO ind_mod = 1, nvar
+ 
+!
+!-- Cycle over Input species  
+
+                   DO ind_inp = 1, nspec_emis_inp
+
+!
+!-- VOCs
+
+                      IF  ( TRIM(emt_att%species_name(ind_inp) ) == "VOC" .AND.    &
+                           ALLOCATED(match_spec_voc_input) )  THEN
+                         
+                         DO ind_voc= 1, emt_att%nvoc
+                            IF  ( TRIM( emt_att%voc_name(ind_voc) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                               len_index = len_index + 1
+                               len_index_voc = len_index_voc + 1
+                        
+                               match_spec_input(len_index) = ind_inp
+                               match_spec_model(len_index) = ind_mod
+
+                               match_spec_voc_input(len_index_voc) = ind_voc
+                               match_spec_voc_model(len_index_voc) = ind_mod                         
+                            ENDIF
+                         END DO
+                      ENDIF
+
+!
+!-- Other Species
+
+                      IF  ( TRIM( emt_att%species_name(ind_inp) ) == TRIM( spc_names(ind_mod) ) )  THEN
+                         len_index = len_index + 1
+                         match_spec_input(len_index) = ind_inp
+                         match_spec_model(len_index) = ind_mod
+                      ENDIF
+
+                   END DO  ! ind_inp
+                END DO     ! ind_mod
+
+             ELSE  ! if len_index_voc .le. 0
+
+!
+!-- in case there are no species matching
+
+                message_string = 'Non of given emission species'            //         &
+                                 ' matches'                                //          &
+                                 ' model chemical species:'                //          &
+                                 ' Emission routine is not called'  
+                CALL message( 'chem_emissions_matching', 'CM0438', 0, 0, 0, 6, 0 )
+             ENDIF
+
+!
+!-- Error check (no matching)
+ 
+          ELSE
+
+!
+!-- either spc_names is zero or nspec_emis_inp is not allocated
+             message_string = 'Array of Emission species not allocated:'              // &
+                              ' Either no emission species are provided as input or'  // &
+                              ' no chemical species are used by PALM:'                // &
+                              ' Emission routine is not called'                  
+             CALL message( 'chem_emissions_matching', 'CM0439', 0, 2, 0, 6, 0 ) 
+
+          ENDIF  
+
+!
+!-- If emission module is switched on but mode_emis is not specified or it is given the wrong name
+
+!
+!-- Error check (no species)
+
        CASE DEFAULT
 
-          message_string = 'Emission Module switched ON, but'            //                         &
-                           ' either no emission mode specified or incorrectly given :'  //          &
+          message_string = 'Emission Module switched ON, but'                           //         &
+                           ' either no emission mode specified or incorrectly given :'  //         &
                            ' please, pass the correct value to the namelist parameter "mode_emis"'                  
           CALL message( 'chem_emissions_matching', 'CM0445', 2, 2, 0, 6, 0 )              
@@ -701,5 +755,5 @@
        END SELECT
 
-       IF ( debug_output )  CALL debug_message( 'chem_emissions_match', 'end' )
+       IF  ( debug_output )  CALL debug_message( 'chem_emissions_match', 'end' )
 
  END SUBROUTINE chem_emissions_match
@@ -724,5 +778,5 @@
 !    
 !-- Actions for initial runs 
-!  IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
+!  IF  (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 !--    ... 
 !    
@@ -735,80 +789,119 @@
 
 
-  IF ( debug_output )  CALL debug_message( 'chem_emissions_init', 'start' )
-
-  !
-  !-- Matching
-  CALL  chem_emissions_match( chem_emis_att, nspec_out )
- 
-  IF ( nspec_out == 0 )  THEN
+    IF  ( debug_output )  CALL debug_message( 'chem_emissions_init', 'start' )
+
+!
+!-- Matching
+
+    CALL  chem_emissions_match( chem_emis_att, n_matched_vars )
+ 
+    IF  ( n_matched_vars == 0 )  THEN
   
-     emission_output_required = .FALSE.
-
-  ELSE
-
-     emission_output_required = .TRUE.
-
-
-     !
-     !-- Set molecule masses' 
-     ALLOCATE( chem_emis_att%xm(nspec_out) )
-
-     DO ispec = 1, nspec_out
-        SELECT CASE ( TRIM( spc_names(match_spec_model(ispec)) ) )
-           CASE ( 'SO2' ); chem_emis_att%xm(ispec) = xm_S + xm_O * 2        !< kg/mole
-           CASE ( 'SO4' ); chem_emis_att%xm(ispec) = xm_S + xm_O * 4        !< kg/mole
-           CASE ( 'NO' ); chem_emis_att%xm(ispec) = xm_N + xm_O             !< kg/mole
-           CASE ( 'NO2' ); chem_emis_att%xm(ispec) = xm_N + xm_O * 2        !< kg/mole   
-           CASE ( 'NH3' ); chem_emis_att%xm(ispec) = xm_N + xm_H * 3        !< kg/mole
-           CASE ( 'CO'  ); chem_emis_att%xm(ispec) = xm_C + xm_O            !< kg/mole
-           CASE ( 'CO2' ); chem_emis_att%xm(ispec) = xm_C + xm_O * 2        !< kg/mole
-           CASE ( 'CH4' ); chem_emis_att%xm(ispec) = xm_C + xm_H * 4        !< kg/mole     
-           CASE ( 'HNO3' ); chem_emis_att%xm(ispec) = xm_H + xm_N + xm_O*3  !< kg/mole  
-           CASE DEFAULT
-              chem_emis_att%xm(ispec) = 1.0_wp
-        END SELECT
-     ENDDO
+       emission_output_required = .FALSE.
+
+    ELSE
+
+       emission_output_required = .TRUE.
+
+
+!
+!-- Set molecule masses  (in kg/mol)
+
+       ALLOCATE( chem_emis_att%xm(n_matched_vars) )
+
+       DO ispec = 1, n_matched_vars
+          SELECT CASE ( TRIM( spc_names(match_spec_model(ispec)) ) )
+             CASE ( 'SO2'  );  chem_emis_att%xm(ispec) = xm_S + xm_O * 2
+             CASE ( 'SO4'  );  chem_emis_att%xm(ispec) = xm_S + xm_O * 4
+             CASE ( 'NO'   );  chem_emis_att%xm(ispec) = xm_N + xm_O
+             CASE ( 'NO2'  );  chem_emis_att%xm(ispec) = xm_N + xm_O * 2
+             CASE ( 'NH3'  );  chem_emis_att%xm(ispec) = xm_N + xm_H * 3
+             CASE ( 'CO'   );  chem_emis_att%xm(ispec) = xm_C + xm_O
+             CASE ( 'CO2'  );  chem_emis_att%xm(ispec) = xm_C + xm_O * 2
+             CASE ( 'CH4'  );  chem_emis_att%xm(ispec) = xm_C + xm_H * 4
+             CASE ( 'HNO3' );  chem_emis_att%xm(ispec) = xm_H + xm_N + xm_O*3
+             CASE DEFAULT
+                chem_emis_att%xm(ispec) = 1.0_wp
+          END SELECT
+       ENDDO
 
     
-     !
-     !-- assign emission values
-     SELECT CASE ( TRIM( mode_emis ) )   
-
-
-        !
-        !-- PRE-PROCESSED case
-        CASE ( "PRE-PROCESSED" )
-
-           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution(nzb:nzt+1,0:ny,0:nx,nspec_out) )  
- 
-           !
-           !-- Get emissions at the first time step
-           CALL chem_emissions_setup( chem_emis_att, chem_emis, nspec_out )
-
-        !
-        !-- Default case
-        CASE ( "DEFAULT" )
-
-           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution(1,0:ny,0:nx,nspec_out) ) 
-
-           !
-           !-- Get emissions at the first time step
-           CALL chem_emissions_setup( chem_emis_att, chem_emis, nspec_out )
-
-        !
-        !-- PARAMETERIZED case
-        CASE ( "PARAMETERIZED" )
-
-           IF ( .NOT. ALLOCATED( emis_distribution) ) ALLOCATE( emis_distribution(1,0:ny,0:nx,nspec_out) )
-
-           !
-           !-- Get emissions at the first time step
-           CALL chem_emissions_setup( chem_emis_att, chem_emis, nspec_out)
-
-     END SELECT
-
-  ENDIF    
-
-  IF ( debug_output )  CALL debug_message( 'chem_emissions_init', 'end' )
+!
+!-- Get emissions for the first time step base on LOD (if defined)
+!-- or emission mode (if no LOD defined)
+
+!
+!-- NOTE - I could use a combined if ( lod = xxx .or. mode = 'XXX' )
+!--        type of decision structure but I think it is much better
+!--        to implement it this way (i.e., conditional on lod if it
+!--        is defined, and mode if not) as we can easily take out
+!--        the case structure for mode_emis later on.
+!--        (ecc 20140424)
+
+       IF   ( emiss_lod < 0 )  THEN  !-- no LOD defined (not likely)
+
+          SELECT CASE ( TRIM( mode_emis ) )   
+
+             CASE ( 'PARAMETERIZED' )     ! LOD 0
+
+                IF  ( .NOT. ALLOCATED( emis_distribution) )  THEN
+                   ALLOCATE( emis_distribution(1,0:ny,0:nx,n_matched_vars) )
+                ENDIF
+
+                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars)
+
+             CASE ( 'DEFAULT' )           ! LOD 1
+
+                IF  ( .NOT. ALLOCATED( emis_distribution) )  THEN
+                   ALLOCATE( emis_distribution(1,0:ny,0:nx,n_matched_vars) )
+                ENDIF
+
+                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
+
+             CASE ( 'PRE-PROCESSED' )     ! LOD 2
+
+                IF  ( .NOT. ALLOCATED( emis_distribution) )  THEN
+                   ALLOCATE( emis_distribution(nzb:nzt+1,0:ny,0:nx,n_matched_vars) )
+                ENDIF
+ 
+                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
+
+          END SELECT
+
+       ELSE  ! if LOD is defined
+
+          SELECT CASE ( emiss_lod )
+
+             CASE ( 0 )     ! parameterized mode
+
+                IF  ( .NOT. ALLOCATED( emis_distribution) )  THEN
+                   ALLOCATE( emis_distribution(1,0:ny,0:nx,n_matched_vars) )
+                ENDIF
+
+                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars)
+
+             CASE ( 1 )     ! default mode
+
+                IF  ( .NOT. ALLOCATED( emis_distribution) )  THEN
+                   ALLOCATE( emis_distribution(1,0:ny,0:nx,n_matched_vars) )
+                ENDIF
+
+                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
+
+             CASE ( 2 )     ! pre-processed mode
+
+                IF  ( .NOT. ALLOCATED( emis_distribution) )  THEN
+                   ALLOCATE( emis_distribution(nzb:nzt+1,0:ny,0:nx,n_matched_vars) )
+                ENDIF
+ 
+                CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
+
+          END SELECT
+
+       ENDIF
+
+    ENDIF
+
+    IF  ( debug_output )  CALL debug_message( 'chem_emissions_init', 'end' )
 
  END SUBROUTINE chem_emissions_init
@@ -822,5 +915,5 @@
 !-------------------------------------------------------------------------------!
 
- SUBROUTINE chem_emissions_setup( emt_att, emt, nspec_out )
+ SUBROUTINE chem_emissions_setup( emt_att, emt, n_matched_vars )
  
    USE surface_mod,                                                  &
@@ -835,10 +928,10 @@
   
 
-    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att                         !< variable to store emission information                                                                           
+    TYPE(chem_emis_att_type), INTENT(INOUT) ::  emt_att                         !< variable to store emission information 
 
     TYPE(chem_emis_val_type), INTENT(INOUT), ALLOCATABLE, DIMENSION(:) ::  emt  !< variable to store emission input values, 
                                                                                 !< depending on the considered species
 
-    INTEGER,INTENT(IN) ::  nspec_out                                            !< Output of matching routine with number
+    INTEGER,INTENT(IN) ::  n_matched_vars                                       !< Output of matching routine with number
                                                                                 !< of matched species
 
@@ -858,6 +951,6 @@
 
     REAL(wp), DIMENSION(24) :: par_emis_time_factor                             !< time factors for the parameterized mode:
-                                                                               !< fixed houlry profile for example day
-    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  conv_to_ratio          !< factor used for converting input 
+                                                                                !< fixed houlry profile for example day
+    REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  conv_to_ratio            !< factor used for converting input 
                                                                                 !< to concentration ratio
     REAL(wp), DIMENSION(nzb:nzt+1,nys:nyn,nxl:nxr) ::  tmp_temp
@@ -883,9 +976,9 @@
     !------------------------------------------------------    
 
-    IF ( emission_output_required )  THEN
+    IF  ( emission_output_required )  THEN
 
        !
        !-- Set emis_dt  
-       IF ( call_chem_at_all_substeps )  THEN
+       IF  ( call_chem_at_all_substeps )  THEN
 
           dt_emis = dt_3d * weight_pres(intermediate_timestep_count)
@@ -897,75 +990,35 @@
        ENDIF
 
-
-       !
-       !-- Conversion of units to the ones employed in PALM 
-       !-- In PARAMETERIZED mode no conversion is performed: in this case input units are fixed
-
-        IF ( TRIM( mode_emis ) == "DEFAULT" .OR. TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
+ !
+ !-- Conversion of units to the ones employed in PALM 
+ !-- In PARAMETERIZED mode no conversion is performed: in this case input units are fixed
+
+        IF  ( TRIM( mode_emis ) == "DEFAULT" .OR. TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
 
           SELECT CASE ( TRIM( emt_att%units ) )
-             !
-             !-- kilograms
-             CASE ( 'kg/m2/s', 'KG/M2/S' ) 
-                
-                con_factor=1
-
-             CASE ('kg/m2/hour', 'KG/M2/HOUR' )
-
-                con_factor=hour_to_s
-
-             CASE ( 'kg/m2/day', 'KG/M2/DAY' ) 
-                
-                con_factor=day_to_s
-
-             CASE ( 'kg/m2/year', 'KG/M2/YEAR' )
-              
-                con_factor=year_to_s
-
-             !
-             !-- Tons
-             CASE ( 'ton/m2/s', 'TON/M2/S' ) 
-               
-                con_factor=tons_to_kg
-
-             CASE ( 'ton/m2/hour', 'TON/M2/HOUR' ) 
-               
-                con_factor=tons_to_kg*hour_to_s
-
-             CASE ( 'ton/m2/year', 'TON/M2/YEAR' ) 
-               
-                con_factor=tons_to_kg*year_to_s
-
-             !
-             !-- Grams
-             CASE ( 'g/m2/s', 'G/M2/S' )
-          
-                con_factor=g_to_kg
-
-             CASE ( 'g/m2/hour', 'G/M2/HOUR' ) 
-
-                con_factor=g_to_kg*hour_to_s
-
-             CASE ( 'g/m2/year', 'G/M2/YEAR' )
- 
-                con_factor=g_to_kg*year_to_s
-
-             !
-             !-- Micrograms
-             CASE ( 'micrograms/m2/s', 'MICROGRAMS/M2/S' )
- 
-                con_factor=miug_to_kg
-
-             CASE ( 'micrograms/m2/hour', 'MICROGRAMS/M2/HOUR' ) 
- 
-                con_factor=miug_to_kg*hour_to_s
-
-             CASE ( 'micrograms/m2/year', 'MICROGRAMS/M2/YEAR' )
-  
-                con_factor=miug_to_kg*year_to_s
+
+             CASE ( 'kg/m2/s',    'KG/M2/S'    );  con_factor = 1.0_wp                   ! kg
+             CASE ( 'kg/m2/hour', 'KG/M2/HOUR' );  con_factor = hour_to_s
+             CASE ( 'kg/m2/day',  'KG/M2/DAY'  );  con_factor = day_to_s
+             CASE ( 'kg/m2/year', 'KG/M2/YEAR' );  con_factor = year_to_s
+
+             CASE ( 'ton/m2/s',    'TON/M2/S'    );  con_factor = tons_to_kg             ! tonnes
+             CASE ( 'ton/m2/hour', 'TON/M2/HOUR' );  con_factor = tons_to_kg*hour_to_s
+             CASE ( 'ton/m2/year', 'TON/M2/YEAR' );  con_factor = tons_to_kg*year_to_s
+
+             CASE ( 'g/m2/s',    'G/M2/S'    );  con_factor = g_to_kg                    ! grams
+             CASE ( 'g/m2/hour', 'G/M2/HOUR' );  con_factor = g_to_kg*hour_to_s
+             CASE ( 'g/m2/year', 'G/M2/YEAR' );  con_factor = g_to_kg*year_to_s
+
+             CASE ( 'micrograms/m2/s',    'MICROGRAMS/M2/S'    );  con_factor = miug_to_kg            ! ug
+             CASE ( 'micrograms/m2/hour', 'MICROGRAMS/M2/HOUR' );  con_factor = miug_to_kg*hour_to_s
+             CASE ( 'micrograms/m2/year', 'MICROGRAMS/M2/YEAR' );  con_factor = miug_to_kg*year_to_s
+
+!
+!-- Error check (need units)
 
              CASE DEFAULT  
-                message_string = 'The Units of the provided emission input' // &
-                                 ' are not the ones required by PALM-4U: please check '      // &
+                message_string = 'The Units of the provided emission input'                 // &
+                                 ' are not the ones required by PALM-4U: please check '     // &
                                  ' emission module documentation.'                                 
                 CALL message( 'chem_emissions_setup', 'CM0446', 2, 2, 0, 6, 0 )
@@ -973,61 +1026,91 @@
           END SELECT
 
-         
        ENDIF
 
-       !
-       !-- Conversion factor to convert  kg/m**2/s to ppm/s
+!
+!-- Conversion factor to convert  kg/m**2/s to ppm/s
+
        DO i = nxl, nxr
           DO j = nys, nyn
-             !
-             !-- Derive Temperature from Potential Temperature
+
+!
+!-- Derive Temperature from Potential Temperature
+
              tmp_temp(nzb:nzt+1,j,i) = pt(nzb:nzt+1,j,i) * ( hyp(nzb:nzt+1) * pref_i )**r_cp
-             
-             
-             !>  We need to pass to cssws <- (ppm/s) * dz 
-             !>  Input is Nmole/(m^2*s)
-             !>  To go to ppm*dz multiply the input by (m**2/N)*dz
-             !>  (m**2/N)*dz == V/N 
-             !>  V/N = RT/P 
-             !>  m**3/Nmole               (J/mol)*K^-1           K                      Pa         
+ 
+!            
+!-- We need to pass to cssws <- (ppm/s) * dz 
+!-- Input is Nmole/(m^2*s)
+!-- To go to ppm*dz multiply the input by (m**2/N)*dz
+!-- (m**2/N)*dz == V/N 
+!-- V/N = RT/P 
+
+!                   m**3/Nmole               (J/mol)*K^-1           K                      Pa         
              conv_to_ratio(nzb:nzt+1,j,i) = ( (Rgas * tmp_temp(nzb:nzt+1,j,i)) / ((hyp(nzb:nzt+1))) )  
+
           ENDDO
        ENDDO
 
 
-       !
-       !-- Initialize
+!
+!-- Initialize
+
        emis_distribution(:,nys:nyn,nxl:nxr,:) = 0.0_wp
 
   
-       !
-       !-- PRE-PROCESSED MODE 
-       IF ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
-
-          !
-          !-- Update time indices
+!
+!-- LOD 2 (PRE-PROCESSED MODE)
+
+       IF  ( emiss_lod == 2 )  THEN
+
+! for reference (ecc)
+!       IF  ( TRIM( mode_emis ) == "PRE-PROCESSED" )  THEN
+
+!
+!-- Update time indices
+
           CALL time_preprocessed_indices( index_hh )
 
-       ELSEIF ( TRIM( mode_emis ) == "DEFAULT" )  THEN
-
-          !
-          !-- Allocate array where to store temporary emission values      
-          IF ( .NOT. ALLOCATED(emis) ) ALLOCATE( emis(nys:nyn,nxl:nxr) )
-          !
-          !-- Allocate time factor per category
-          ALLOCATE( time_factor(emt_att%ncat) )  
-          !
-          !-- Read-in hourly emission time factor
-          IF ( TRIM( time_fac_type ) == "HOUR" )  THEN
-
-             !
-             !-- Update time indices
+
+!
+!-- LOD 1 (DEFAULT MODE)
+
+        ELSEIF  ( emiss_lod == 1 )  THEN
+
+! for reference (ecc)
+!       ELSEIF  ( TRIM( mode_emis ) == "DEFAULT" )  THEN
+
+!
+!-- Allocate array where to store temporary emission values
+
+          IF  ( .NOT. ALLOCATED(emis) ) ALLOCATE( emis(nys:nyn,nxl:nxr) )
+
+!
+!-- Allocate time factor per category
+
+          ALLOCATE( time_factor(emt_att%ncat) )
+
+!
+!-- Read-in hourly emission time factor
+
+          IF  ( TRIM(time_fac_type) == "HOUR" )  THEN
+
+!
+!-- Update time indices
+
              CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
-             !
-             !-- Check if the index is less or equal to the temporal dimension of HOURLY emission files              
-             IF ( index_hh <= SIZE( emt_att%hourly_emis_time_factor(1,:) ) )  THEN
-                !
-                !-- Read-in the correspondant time factor              
+
+!
+!-- Check if the index is less or equal to the temporal dimension of HOURLY emission files
+
+             IF  ( index_hh <= SIZE( emt_att%hourly_emis_time_factor(1,:) ) )  THEN
+
+!
+!-- Read-in the correspondant time factor
+
                 time_factor(:) = emt_att%hourly_emis_time_factor(:,index_hh)      
+
+!
+!-- Error check (time out of range)
 
              ELSE
